#----------------------------------------------------------------------
class Statistics:
    times = 0 
    baslints = 0
    lines = 0
    triangle = 0
    triaok = 0
    triatri = 0
    baslok = {}
    basltot = {}
    def __init__(self, andict ):
        self.andict = andict

    def __repr__(self):
        output = 'Statistics: times: %s, baseline-intervals: %s, fringe-rates: %s\n          : triangles: %s, of which have data: %s complete triangles: %s \n' % (
            self.times, 
            self.baslints, 
            self.lines,            
            self.triangle,
            self.triaok,
            self.triatri)

        output = output + '    '+'Basl '+'Tot'+' OK\n'
        for basl in self.baslok:
            output = output + '    '+basl+'   '+str(self.basltot[basl])
            if self.baslok.has_key(basl):
                output = output + ' '+str(self.baslok[basl]) + '\n'
            else:
                output = output + ' 0' + '\n'
        return output


    def count(self,key):
        if key == 'times':
            self.times = self.times +1
        elif key == 'baslints':
            self.baslints = self.baslints +1
        elif key == 'lines':
            self.lines = self.lines +1
        elif key == 'triangle':
            self.triangle = self.triangle +1
        elif key == 'triaok':
            self.triaok = self.triaok +1
        elif key == 'triatri':
            self.triatri = self.triatri +1
        else:
            raise 'Unknown key for counting'

    def countbaslok(self,iant,jant):
        basl = self.andict[iant]+self.andict[jant]
        #print basl, self.baslok
        if self.baslok.has_key(basl):
            self.baslok[basl] = self.baslok[basl]+1
        else:
            self.baslok.update({basl:1})

    def countbasltot(self,iant,jant):
        basl = self.andict[iant]+self.andict[jant]
        if self.basltot.has_key(basl):
            self.basltot[basl] = self.basltot[basl]+1
        else:
            self.basltot.update({basl:1})



#----------------------------------------------------------------------
class BaslCols:

    mycol=['r','g','b','k','m',
           'darkcyan','orange','maroon',
           'navy','teal', 'gray', 'purple'] #omitting 'y' and 'w'
    def __init__( self ):
        self.colstate = {}
        self.ncol = 0

    def genuni( self, baskey ):

        new = False
        icol = None
        if baskey in self.colstate:
            icol = self.colstate[baskey]
        else:
            icol = self.ncol
            new = True
            self.ncol= self.ncol+1
            if self.ncol >= len( self.mycol ): self.ncol = 0
            self.colstate.update({baskey:icol})

        return ( new, self.mycol[icol] )
#----------------------------------------------------------------------
def anselect( uvandict, userlist ):

    outlist = []
    if userlist == 'all':
        outlist = uvandict.keys()
    else:
        for iant in uvandict:
            code = uvandict[iant]
            if userlist.find(code) >= 0:
                outlist.append(iant)

    return outlist

def intersec( tlin, ant11, ant12, ant21, ant22 ):
    from math import sqrt
    a1 = None; a2 = None
    b1 = None; b2 = None
    c1 = None; c2 = None
    for i in range(len(tlin)):
        if (ant11 == tlin[i]['basl'][0] and 
            ant12 == tlin[i]['basl'][1] ):
            a1 = tlin[i]['a']
            b1 = tlin[i]['b']
            c1 = tlin[i]['fr']
            dc1 = tlin[i]['dfr']
        if (ant21 == tlin[i]['basl'][0] and 
            ant22 == tlin[i]['basl'][1] ):
            a2 = tlin[i]['a']
            b2 = tlin[i]['b']
            c2 = tlin[i]['fr']
            dc2 = tlin[i]['dfr']

    if a1 and a2 and b1 and b2 and c1 and c2:
        ddec = ((a2/a1)*c1-c2)/((a2/a1)*b1-b2)
        sdec = sqrt((dc2/((a2/a1)*b1-b2))**2+
                    ((a2/a1)*dc1/((a2/a1)*b1-b2))**2)
        dra = (c1-b1*ddec)/a1
        sdra = sqrt( (dc1/a1)**2 + (b1*sdec/a1)**2 )
        #print 'new: ', dra, sdra, ddec, sdec
        return ( dra, ddec, sdra, sdec )
    else:
        return (None, None, None, None)
#----------------------------------------------------------------------
def triasect( lines, iant, jant, kant ):
    import math
    dra = [None,None,None]
    ddec = [None,None,None]
    sra = [None,None,None]
    sdec = [None,None,None]

    (dra[0], ddec[0], sra[0], sdec[0] ) = intersec( lines, iant,jant, 
                                                     iant,kant )
    (dra[1], ddec[1], sra[1], sdec[1] ) = intersec( lines, iant,jant, 
                                                     jant,kant )
    (dra[2], ddec[2], sra[2], sdec[2] ) = intersec( lines, iant,kant, 
                                                     jant,kant )

    sumdra = 0
    sumddec = 0
    wdra = 0
    wddec = 0
    sumwra = 0
    sumwdec = 0
    xdra = 0
    xddec = 0
    isum = 0


    #print 'compare:',iant,jant,kant
    for i in range(3):
        #print 'i',i,dra[i],ddec[i]
        if dra[i] and ddec[i]:
            isum = isum+1
            sumdra = sumdra + dra[i]
            sumddec = sumddec + ddec[i]
            if sra[i] and sdec[i]:
                #print i,dra[i],ddec[i],sra[i],sdec[i]
                sumwra = sumwra+1./sra[i]**2
                sumwdec = sumwdec+1./sdec[i]**2
                wdra = wdra + dra[i]/sra[i]**2
                wddec = wddec + ddec[i]/sdec[i]**2
                #xdra = xdra + sra[i]**4
                #xddec = xddec + sdec[i]**4

    trifit = { 'tria': [iant,jant,kant] }
    if isum != 3 and isum != 0: print 'ISUM:',isum, 'triangle:', iant, jant, kant
    if (isum):
        sumdra = sumdra/isum
        sumddec = sumddec/isum
        wdra = wdra/sumwra
        wddec = wddec/sumwdec
        xdra = math.sqrt(isum/sumwra)
        xddec = math.sqrt(isum/sumwdec)
        #print sumdra,wdra,xdra,sumddec,wddec,xddec
        trifit.update( {'dra_unw': sumdra, 'ddec_unw':sumddec,
                       'dra_w': wdra, 'ddec_w': wddec,
                       'dra_sig': xdra, 'ddec_sig': xddec,
                       'nsol': isum })
    else:
        trifit.update( {'nsol': 0})
    return trifit

#---------------------------------------------------------------------
#---------------------------------------------------------------------
def plotfrpos(w,tripos,andict,root,interactive):
    import math
    import pylab as pl

    if not len(tripos): return (0, 0, 0, 0)
    pl.title("frpos: positions of fringe rate triangles")
    pl.ylabel('Dec ["]')
    pl.xlabel('RA cosd ["]')

    col = BaslCols()
    dolegend = False

    x = []
    y = []
    for i in range(len(tripos)):

        if tripos[i]['dra_unw'] and tripos[i]['ddec_unw']:
            xp = tripos[i]['dra_unw']
            yp = tripos[i]['ddec_unw']
            x.append(xp)
            y.append(yp)
    
            triang = (andict[tripos[i]['tria'][0]]+'-'+
                      andict[tripos[i]['tria'][1]]+'-'+
                      andict[tripos[i]['tria'][2]] )
            ( dolegend, icol ) = col.genuni( triang )
            if dolegend:
                pl.plot( xp, yp, 'o', alpha = 0.6, 
                         color = icol,
                         label=triang )
            else:
                pl.plot( xp, yp, 'o', alpha = 0.6, 
                         color = icol )

    pl.axis([w,-1*w,-1.*w,w])
    leg = pl.legend( numpoints = 1 )
    # matplotlib.text.Text instances
    for t in leg.get_texts():
        t.set_fontsize('small')    # the legend text fontsize
    # matplotlib.lines.Line2D instances
    for l in leg.get_lines():
        l.set_linewidth(1.5)  # the legend line width

    if interactive:
        print ' Interactive'
        pl.show()
    else:
        plfile = root+'_frpos.pdf'
        print 'Printing ',plfile 
        pl.savefig(plfile)

    pl.close()

    #pl.scatter( x, y)
    #pl.axis([w,-1*w,-1.*w,w])
    #pl.show()

    #print 'cols', triacol
    posra = 0
    posdec = 0
    sqra = 0
    sqdec = 0
    nsamp = len(x)
    for i in range(len(x)):
        posra = posra + x[i]
        posdec = posdec + y[i]
        sqra = sqra + x[i]*x[i]
        sqdec = sqdec + y[i]*y[i]
        
    #print 'stats ',nsamp,posra,posdec,sqra,sqdec
    if nsamp > 0:
        posdec = posdec / nsamp
        posra = posra / nsamp
        sqra = math.sqrt(sqra/nsamp - posra**2)
        sqdec = math.sqrt(sqdec/nsamp - posdec**2)

        #sigra = 0
        #sigdec = 0
        #for i in range(len(x)):
        #    sigraFr = sigra + (x[i]-posra)**2
        #    sigdec = sigdec + (y[i]-posdec)**2
        #
        #sigra = math.sqrt(sigra/nsamp)
        #sigdec = math.sqrt(sigdec/nsamp)
        #print '  check sigra,dec:', sigra,sigdec
        #print '  ers:',sqra,sqdec
 
    return ( posra, posdec, sqra, sqdec )
#----------------------------------------------------------------------
def plotfrwgh(w,tripos,andict,root,interactive):
    import math
    import pylab as pl

    if not len(tripos): return ( 0, 0, 0, 0)
    pl.title("frpos: positions of weighted fringe rate triangles")
    pl.ylabel('Dec ["]')
    pl.xlabel('RA cosd ["]')

    col = BaslCols()
    dolegend = False

    x = []
    y = []
    sx = []
    sy = []
    posra = 0
    posdec = 0
    sqra = 0
    sqdec = 0
    sumwx = 0
    sumwy = 0
    for i in range(len(tripos)):
        if tripos[i]['dra_w'] and tripos[i]['ddec_w']:
            xp = tripos[i]['dra_w']
            yp = tripos[i]['ddec_w']
            sxp = tripos[i]['dra_sig']
            syp = tripos[i]['ddec_sig']
            x.append(xp)
            y.append(yp)
            sx.append(sxp)
            sy.append(syp)
    #print 'cols', triacol
            posra = posra + xp/sxp**2
            posdec = posdec + yp/syp**2
            sumwx = sumwx + 1./sxp**2
            sumwy = sumwy + 1./syp**2

    nsamp = len(x)
    kra = 1
    kdec = 1
    if nsamp > 0:
        posdec = posdec / sumwy
        posra = posra / sumwx
        sqra = math.sqrt(nsamp/sumwx)
        sqdec = math.sqrt(nsamp/sumwy)

        chira = 0
        chidec = 0

        for i in range(len(x)):
            chira = chira + ((x[i]-posra)/sx[i])**2
            chidec = chidec + ((y[i]-posdec)/sy[i])**2

        print '  nsamp = chi^2?', nsamp, chira, chidec

        if nsamp > 2 and chira != 0 and chidec != 0:
            kra = chira/nsamp
            kdec = chidec/nsamp

    #print nsamp,sumwx,kra
    sqra = math.sqrt(nsamp/(sumwx/kra))
    sqdec = math.sqrt(nsamp/(sumwy/kdec))

    for i in range(len(tripos)):
        if tripos[i]['dra_w'] and tripos[i]['ddec_w']:
            xp = tripos[i]['dra_w']
            yp = tripos[i]['ddec_w']
            sxp = tripos[i]['dra_sig']*math.sqrt(kra)
            syp = tripos[i]['ddec_sig']*math.sqrt(kdec)
            triang = (andict[tripos[i]['tria'][0]]+'-'+
                      andict[tripos[i]['tria'][1]]+'-'+
                      andict[tripos[i]['tria'][2]] )
            ( dolegend, icol ) = col.genuni( triang )
            if dolegend:
                pl.errorbar( xp, yp, syp, sxp, 'o', alpha = 0.6, 
                         color = icol,
                         label=triang )
            else:
                pl.errorbar( xp, yp, syp, sxp, 'o', alpha = 0.6, 
                         color = icol )

    pl.axis([w,-1*w,-1.*w,w])
    leg = pl.legend( numpoints = 1 )
    # matplotlib.text.Text instances
    for t in leg.get_texts():
        t.set_fontsize('small')    # the legend text fontsize
    # matplotlib.lines.Line2D instances
    for l in leg.get_lines():
        l.set_linewidth(1.5)  # the legend line width

    if interactive:
        print ' Interactive'
        pl.show()
    else:
        plfile = root+'_frwgh.pdf'
        print 'Printing ',plfile 
        pl.savefig(plfile)

    pl.close()

    return ( posra, posdec, sqra, sqdec )

#----------------------------------------------------------------------
def plotfrmap(w,lines, andict, root, interactive):
    import pylab as pl

    pl.title("frmap: fringe rate map")
    pl.ylabel('Dec ["]')
    pl.xlabel('RA cosd ["]')
    #.................................................................
    def plotline(a,b,c,w,scol,style,basl=None):
        x = []
        y = []
        
        if a > b:
            #y is the faster coordinate
            for j in range(-1,2,1):
                yc = float(j)*w
                #print 'y',j, yc,scol
                y.append(yc)
                x.append((c-b*yc)/a)
        else:
            for j in range(-1,2,1):
                xc = float(j)*w
                #print 'x',j, xc, scol
                x.append(xc)
                y.append((c-a*xc)/b)

        pl.plot(x, y, style, color=scol, label=basl )
    #.................................................................
    col = BaslCols()
    dolegend = False

    solid = '-'
    dashed = ':'

    for i in range(len(lines)):
        for j in range(len(lines[i])):
            if lines[i][j]['fr'] and lines[i][j]['a'] and lines[i][j]['b']:
                basl = (andict[lines[i][j]['basl'][0]]+'-'+
                        andict[lines[i][j]['basl'][1]] )
                (dolegend, icol ) = col.genuni( basl )  
                #print 'plot this',i,j,lines[i][j]['basl'],dolegend,icol
                #print 'ok?',lines[i][j]

                if dolegend:
                    plotline(lines[i][j]['a'],lines[i][j]['b'],
                             lines[i][j]['fr'], w, icol,
                             solid,basl=basl)
                else:
                    plotline(lines[i][j]['a'],lines[i][j]['b'],
                             lines[i][j]['fr'], w, icol,
                             solid)

                plotline(lines[i][j]['a'],lines[i][j]['b'],
                         lines[i][j]['fr']+lines[i][j]['dfr'],
                         w, icol, dashed)
                plotline(lines[i][j]['a'],lines[i][j]['b'],
                         lines[i][j]['fr']-lines[i][j]['dfr'],
                         w, icol, dashed)

    pl.axis([w,-1*w,-1.*w,w])
    leg = pl.legend()
    # matplotlib.text.Text instances
    for t in leg.get_texts():
        t.set_fontsize('small')    # the legend text fontsize
    # matplotlib.lines.Line2D instances
    for l in leg.get_lines():
        l.set_linewidth(1.5)  # the legend line width
    if interactive:
        pl.show()
    else:
        plfile = root+'_frmap.pdf'
        print 'Printing ',plfile 
        pl.savefig(plfile)

    pl.close()

#----------------------------------------------------------------------
def ploterdist( lines, andict, root, interactive):
    import pylab as pl
    import math

    pl.title("erdist: error distribution")
    pl.ylabel('dfr [mHz]')
    pl.xlabel('uv speed')

    col = BaslCols()
    dolegend = False
    solid = '-'
    dashed = ':'

    print len(lines),len(lines[0])
    for i in range(len(lines)):
        for j in range(len(lines[i])):
            if lines[i][j]['a'] and lines[i][j]['b'] and lines[i][j]['dfr']:
                uvspeed = math.sqrt( lines[i][j]['a']**2 + lines[i][j]['b']**2 )
                error = lines[i][j]['dfr']/uvspeed
                basl = (andict[lines[i][j]['basl'][0]]+'-'+
                        andict[lines[i][j]['basl'][1]] )
                (dolegend, icol ) = col.genuni( basl )  
                #print 'plot this',i,j,lines[i][j]['basl'],dolegend,icol
                #print 'ok?',lines[i][j]

                #print uvspeed, error
                if dolegend:
                    pl.semilogy( uvspeed, error,'o', color = icol, label = basl )
                else:
                    pl.semilogy( uvspeed, error,'o', color = icol )

    #pl.axis([w,-1*w,-1.*w,w])
    leg = pl.legend()
    # matplotlib.text.Text instances
    for t in leg.get_texts():
        t.set_fontsize('small')    # the legend text fontsize
    # matplotlib.lines.Line2D instances
    for l in leg.get_lines():
        l.set_linewidth(1.5)  # the legend line width
    if interactive:
        pl.show()
    else:
        plfile = root+'_erdist.pdf'
        print 'Printing ',plfile 
        pl.savefig(plfile)

    pl.close()
#----------------------------------------------------------------------
def plotuvdetect( lines, andict, root, interactive ):
    import pylab as pl

    pl.title("uvplot: uv distribution detections")
    pl.ylabel('V [k]')
    pl.xlabel('U [k]')

    def uvseg(u1,u2,v1,v2,scol,style,basl=None):
        x = []
        y = []
        
        x.append(u1)
        x.append(u2)
        y.append(v1)
        y.append(v2)

        pl.plot(x, y, style, color=scol, label=basl, linewidth=3 )

        u = []
        v = []
        
        u.append(-1*u1)
        u.append(-1*u2)
        v.append(-1*v1)
        v.append(-1*v2)

        pl.plot(u, v, style, color=scol, linewidth=3 )

    col = BaslCols()
    dolegend = False
    solid = '-'
    dashed = ':'

    for i in range(len(lines)):
        for j in range(len(lines[i])):
            if lines[i][j]['u1'] and lines[i][j]['v1']:
                basl = (andict[lines[i][j]['basl'][0]]+'-'+
                        andict[lines[i][j]['basl'][1]] )
                ( dolegend, icol) = col.genuni( basl )
                type = dashed
                if lines[i][j]['fr']:
                    type = solid
                if dolegend:
                    uvseg(lines[i][j]['u1'],lines[i][j]['u2'],
                          lines[i][j]['v1'],lines[i][j]['v2'],
                          icol,
                          type,basl=basl)
                else:
                    uvseg(lines[i][j]['u1'],lines[i][j]['u2'],
                          lines[i][j]['v1'],lines[i][j]['v2'],
                          icol,
                          type)
    leg = pl.legend()
    # matplotlib.text.Text instances
    for t in leg.get_texts():
        t.set_fontsize('small')    # the legend text fontsize
    # matplotlib.lines.Line2D instances
    for l in leg.get_lines():
        l.set_linewidth(1.5)  # the legend line width

    if interactive:
        pl.show()
    else:
        plfile = root+'_uvtr.pdf'
        print 'Printing ',plfile 
        pl.savefig(plfile)

    pl.close()

def annames( andict, selectan):
    output = ''
    for i in range(len(selectan)):
        output = output + str(andict[selectan[i]])

    return output
